"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_redux_1 = require("react-redux");
var recompose_1 = require("recompose");
var utils_1 = require("../../utils");
var betterRecompose_1 = require("./betterRecompose");
/**
 * Automatically sync with current URL by requesting data from server using
 * said URL. This is assuming there is data provided by the server at current
 * URL, e.g. user navigates to /users/1, this will send a GET request to
 * /users/1, which should have a defined backend route that contains the
 * relevant data.
 * This HOC is usually used for components rendered by a Route.
 */
function autoURLDataSync() {
    var _this = this;
    return betterRecompose_1.createEnhancerChain()
        .compose(react_redux_1.connect(function (_a) {
        var urlDataSync = _a.repository.urlDataSync;
        return ({
            urlDataSync: urlDataSync
        });
    }))
        .compose(betterRecompose_1.withState("data", "setData", undefined))
        .compose(betterRecompose_1.withState("isLoadingData", "setIsLoadingData", false))
        .compose(betterRecompose_1.withState("urlQuery", "setURLQuery", {}))
        .compose(recompose_1.mapProps(function (_a) {
        var urlDataSync = _a.urlDataSync, data = _a.data, setData = _a.setData, setIsLoadingData = _a.setIsLoadingData, setURLQuery = _a.setURLQuery, rest = __rest(_a, ["urlDataSync", "data", "setData", "setIsLoadingData", "setURLQuery"]);
        var getData = function () { return __awaiter(_this, void 0, void 0, function () {
            var newData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, , 2, 3]);
                        setIsLoadingData(true);
                        return [4 /*yield*/, urlDataSync.get()];
                    case 1:
                        newData = _a.sent();
                        setData(newData);
                        return [3 /*break*/, 3];
                    case 2:
                        setIsLoadingData(false);
                        return [7 /*endfinally*/];
                    case 3: return [2 /*return*/];
                }
            });
        }); };
        return __assign({}, rest, { data: data,
            getData: getData,
            setURLQuery: setURLQuery,
            urlDataSync: urlDataSync, saveData: function () { return __awaiter(_this, void 0, void 0, function () {
                var updated;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, , 2, 3]);
                            setIsLoadingData(true);
                            return [4 /*yield*/, urlDataSync.update(data)];
                        case 1:
                            updated = _a.sent();
                            setData(updated);
                            return [3 /*break*/, 3];
                        case 2:
                            setIsLoadingData(false);
                            return [7 /*endfinally*/];
                        case 3: return [2 /*return*/];
                    }
                });
            }); }, updateData: function (newData) {
                return setData(Object.assign({}, data, newData));
            }, updateURLQuery: function () {
                var queries = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    queries[_i] = arguments[_i];
                }
                return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                setURLQuery(utils_1.mergeQueryMaps.apply(void 0, queries));
                                return [4 /*yield*/, urlDataSync.updateURLQuery.apply(urlDataSync, queries)];
                            case 1:
                                _a.sent();
                                return [4 /*yield*/, getData()];
                            case 2:
                                _a.sent();
                                return [2 /*return*/];
                        }
                    });
                });
            } });
    }))
        .compose(betterRecompose_1.lifecycle({
        componentDidMount: function () {
            return __awaiter(this, void 0, void 0, function () {
                var _a, urlDataSync, getData, setURLQuery, query;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = this.props, urlDataSync = _a.urlDataSync, getData = _a.getData, setURLQuery = _a.setURLQuery;
                            return [4 /*yield*/, urlDataSync.getURLQuery()];
                        case 1:
                            query = _b.sent();
                            setURLQuery(query);
                            return [4 /*yield*/, getData()];
                        case 2:
                            _b.sent();
                            return [2 /*return*/];
                    }
                });
            });
        }
    })).enhance;
}
exports.autoURLDataSync = autoURLDataSync;
